'Bivariate Gaussian contour
'specified by mean M (vector) and covariance COV (matrix)

!debug = 1
if !debug = 0 then
	logmode +addin
endif

'check a workfile exists
%wfname = @wfname
if %wfname="" then
	@uiprompt("No workfile is open")
	stop
endif
!doGui = 1

%mean = ""
%covaraince = ""
%graph = ""
!step = 1000

if @len(@option(1)) > 0 then
	%temp = @equaloption("m")
	if @len(%temp) > 0 then
		%mean = %temp
	endif
	%temp = @equaloption("cov")
	if @len(%temp) > 0 then
		%covariance = %temp
	endif
	%temp = @equaloption("out")
	if @len(%temp) > 0 then
		%graph = %temp
	endif	
	!doGui = 0
endif
	
if !doGui = 1 then
	!result = @uidialog("caption","Gaussian Contour", _
	"edit",%mean,"Mean (2-by-1 vector)", 100, _
	"edit",%covariance,"Covariance (2-by-2 symmetrix matrix)", 100, _
	"edit", %graph,"Output graph name (optional)", 50)
	if !result = -1 then
		stop
	endif
endif
%err = "Invalid size for mean and/or covariance" 
if @rows({%mean})<>2 or @rows({%covariance})<>2 or @columns({%covariance})<>2 then
	@uiprompt(%err)
	stop
endif

%m = @getnextname("_mean")
%cov = @getnextname("_cov")
matrix(2,1) {%m} = {%mean}
sym(2) {%cov} = {%covariance}

%grid = @getnextname("_grid")
vector(!step) {%grid}
!int = 2*@acos(-1)/(!step-1)
for !i = 1 to !step-1
	{%grid}(!i+1) = !int*!i
next
{%grid}(!step) = 2*@acos(-1)

%xvals = @getnextname("_xvals")
%yvals = @getnextname("_yvals")
vector {%xvals} = @cos({%grid})
vector {%yvals} = @sin({%grid})

%data = @getnextname("_data")
matrix(2,!step) {%data}
matplace({%data},@transpose({%xvals}),1,1)
matplace({%data},@transpose({%yvals}),2,1)
d(noerr) {%xvals} {%yvals} {%grid}

'means: tile of copies of mean vector 
%temp1 = @getnextname("_temp1")
%temp2 = @getnextname("_temp2")
rowvector {%temp1} = @filledrowvector(!step,{%m}(1))
rowvector {%temp2} = @filledrowvector(!step,{%m}(2))
%temp = @getnextname("_temp")
matrix {%temp} = @ones(2,!step)
matplace({%temp}, {%temp1}, 1, 1)
matplace({%temp}, {%temp2}, 2, 1)
d(noerr) {%temp1} {%temp2} {%m}

'covs
%evals = @getnextname("_evals")
%evecs = @getnextname("_evecs")
matrix {%evals} = @makediagonal(@eigenvalues({%cov}))
matrix {%evecs} = @eigenvectors({%cov})
d(noerr) {%cov}
%sdw = @getnextname("_sdw")
'matrix {%sdw} = @sqrt(6)*{%evecs}*@sqrt(@abs({%evals})) Mahalanobis radius
matrix {%sdw} = {%evecs}*@sqrt(@abs({%evals}))
d(noerr) {%evals} {%evecs}  

'plot contour
%pts = @getnextname("_pt")
matrix {%pts} = @transpose({%sdw}*{%data} + {%temp})
d(noerr) {%temp} {%data} {%sdw}  

if @wcount(%graph)=0 then
	%graph = @getnextname("_graph")
endif
freeze({%graph}) {%pts}.xyline
{%graph}.legend -display
%title = "Contour plot of bivariate normal with mean vector " + @upper(%mean) + " and covariance matrix " + @upper(%covariance)
{%graph}.addtext(t) %title
d(noerr) {%pts}

